local Sorted = LibStub("Sorted.")

-- Adds a new column that displays CanIMogIt's icon
local CreateElement = function(f)
    f.text = f:CreateFontString(nil, "OVERLAY", "SortedFont")
    f.text:SetAllPoints()
    f.text:SetJustifyH("CENTER")
end
local UpdateElement = function(f, data)
    if data.filtered then
        f.text:SetAlpha(0.4)
        if data.pawn then
            f.text:SetText("|TInterface\\Addons\\Pawn\\Textures\\UpgradeArrow:12:12:0:0:32:32:0:32:0:32:200:80:200|t")
        elseif data.isEquippable then
            f.text:SetText("|TInterface\\Addons\\Pawn\\Textures\\DowngradeArrow:12:12:0:0:32:32:0:32:0:32:80:200:200|t")
        else
            f.text:SetText("")
        end
    else
        f.text:SetAlpha(1)
        if data.pawn then
            f.text:SetText("|TInterface\\Addons\\Pawn\\Textures\\UpgradeArrow:12:12:0:0:32:32:0:32:0:32|t")
        elseif data.isEquippable then
            f.text:SetText("|TInterface\\Addons\\Pawn\\Textures\\DowngradeArrow:12:12:0:0:32:32:0:32:0:32|t")
        else
            f.text:SetText("")
        end
    end
end
Sorted:AddItemColumn("PAWN", "Pawn", 20, CreateElement, UpdateElement)

-- Add sorting
local Sort = function(asc, data1, data2)
    local sortOrder1, sortOrder2
    if data1.pawn then
        sortOrder1 = 2
    elseif data1.isEquippable then
        sortOrder1 = 1
    else
        sortOrder1 = 0
    end
    if data2.pawn then
        sortOrder2 = 2
    elseif data2.isEquippable then
        sortOrder2 = 1
    else
        sortOrder2 = 0
    end
    if sortOrder1 == sortOrder2 then
        return Sorted.DefaultItemSort(data1, data2)
    end
    if asc then
        return sortOrder1 < sortOrder2
    else
        return sortOrder1 > sortOrder2
    end
end
Sorted:AddSortMethod("PAWN", "|TInterface\\Addons\\Pawn\\Textures\\PawnLogo:20:20:0:0:256:128:0:128:0:128|t", Sort, false)

local PreSort = function(itemData)
    if Sorted.IsPlayingCharacterSelected() and not itemData.isGuild then
        if itemData.link then
            itemData.pawn = PawnShouldItemLinkHaveUpgradeArrow(itemData.link, true, true)
        else
            itemData.pawn = false
        end
    end
end
Sorted:AddDataToItem("PAWN", PreSort)